在 Bash 中检查退出代码

Muhammad Husnain 2022年6月15日
在 Bash 中检查退出代码

本教程将介绍几种在 Bash 中获取和显示语句退出状态的方法。我们将首先讨论使用简单的 if 语句来获取退出状态,然后我们将讨论用于获取退出状态的替代方法和简写符号。

检查 Bash 中的退出代码

退出状态本质上是一个整数,告诉我们命令是否成功。不直观地,退出状态 0 表示成功,任何非零值表示失败/错误。

这种非直观的解决方案允许不同的错误代码表示不同的错误。例如,如果没有找到命令,则返回 127 的退出状态。

在 Bash 中检查退出代码的方法是使用 $? 命令。如果你希望输出退出状态,可以通过以下方式完成:

# your command here
testVal=$?
echo testVal

我们知道非零退出代码用于报告错误。如果我们想检查一般的错误,我们可以编写一个小脚本,其中包含有问题的命令和一个 if 语句来检查退出代码是否存在错误(非零)或退出代码是否指示正确执行.

# your command here
testVal=$?
if [$testVal -ne 0]; then
    echo "There was some error"
fi
exit $testVal

可以使用 $? 上的 test 来完成速记符号命令。此代码的最小示例可以是:

# your command here
test $? -eq 0 || echo "There was some error"

为了更好地理解上述陈述,我们可以对其进行扩展。

# your command here
exitStat = $?
test $exitStat -eq 0 && echo "No error! Worked fine" || echo "There was some error";
exit $exitStat

在上面,我们可以看到成功执行时的 "No error! Worked fine" 消息,以及失败时的错误消息。

重要说明和可能的替代解决方案

如果使用退出代码来查看命令是否正确执行,我们有一个更简单的选择。

# define your_command here
# your_command = enter a command here
if your_command; then
    echo command returned true
else
    echo command returned an error
fi

在这种情况下,我们通常会得到与使用前几个选项相同的输出。此外,获取有关退出代码的特定信息或获取特定退出代码需要手动运行 $?

Muhammad Husnain avatar Muhammad Husnain avatar

Husnain is a professional Software Engineer and a researcher who loves to learn, build, write, and teach. Having worked various jobs in the IT industry, he especially enjoys finding ways to express complex ideas in simple ways through his content. In his free time, Husnain unwinds by thinking about tech fiction to solve problems around him.

LinkedIn